<?php

namespace CityBeach\CatchFeeder\Block;

use Magento\Integration\Api\IntegrationServiceInterface;
use \Magento\Integration\Model\OauthService;

class ConnectButton extends \Magento\Framework\View\Element\Template
{
    /**
     * @var string
     */
    protected $_template = 'CityBeach_CatchFeeder::connectbutton.phtml';

    /**
     * @var string
     */
    protected $baseUrl;

    /**
     * @var string
     */
    protected $emailAddress;

    /**
     * @var string
     */
    protected $accessToken;

    /**
     * @var string
     */
    protected $storeName;


    /**
     * @param IntegrationServiceInterface $integrationService
     * @param OauthService $oauthService
     */
    public function __construct(
        \Magento\Backend\Block\Template\Context $context,
        IntegrationServiceInterface $integrationService,
        OauthService $oauthService,
        array $data = []
    ) {
        $name = 'CityBeach';
        $integration = $integrationService->findByName($name);
        $consumer_id = $integration->getConsumerId();
        $token = $oauthService->getAccessToken($consumer_id);
        $this->emailAddress = $integration->getEmail();
        $this->accessToken = $token->getToken();
        $this->baseUrl = $context->getUrlBuilder()->getBaseUrl();
        $this->storeName = $context->getStoreManager()->getStore()->getName();
        parent::__construct($context, $data);
    }

    /**
     * @return string
     */
    public function getBaseUrl()
    {
        return $this->baseUrl;
    }

    /**
     * @return string
     */
    public function getEmailAddress()
    {
        return $this->emailAddress;
    }

    /**
     * @return string
     */
    public function getAccessToken()
    {
        return $this->accessToken;
    }

    /**
     * @return string
     */
    public function getStoreName()
    {
        return $this->storeName;
    }
}
