<?php

namespace CityBeach\CatchFeeder\Model;

use \Magento\Framework\App\ProductMetadataInterface;
use \Magento\Framework\ObjectManagerInterface;
use \Magento\Framework\Module\ModuleListInterface;
use \CityBeach\CatchFeeder\Api\CityBeachInterface;

class CityBeach implements CityBeachInterface
{
    /**
     * @var \Magento\Framework\App\ProductMetadataInterface
     */
    protected $productMetadata;

    /**
     * @var \Magento\Framework\Module\ModuleListInterface
     */
    protected $moduleList;

    /*
     * @var \Magento\Framework\ObjectManagerInterface $objectManager
     */
    private $objectManager;

  /**
   * @param ObjectManagerInterface $objectManager
   * @param ProductMetadataInterface $productMetadata
   * @param \Magento\Framework\Module\ModuleListInterface $moduleList
   */
    public function __construct(
        ObjectManagerInterface $objectManager,
        ProductMetadataInterface $productMetadata,
        ModuleListInterface $moduleList)
    {
        $this->objectManager = $objectManager;
        $this->productMetadata = $productMetadata;
        $this->moduleList = $moduleList;
    }

    /**
     * Query magento for system and debugging information.
     *
     * @api
     * @return array
     */
    public function execute() {
      $php_version = phpversion();
      $magento_version = $this->productMetadata->getVersion();
      $plugin_versions = array();

      $modules_metadatas = $this->moduleList->getAll();
      foreach ($modules_metadatas as $module_name => $modules_metadata)
      {
        $module_name_lowercase = strtolower($module_name);
        if (strpos($module_name_lowercase, 'citybeach') === 0)
        {
          $plugin_versions[$module_name] = $modules_metadata;
        }
      }

      return [[
        'php_version' => $php_version,
        'magento_version' => $magento_version,
        'plugins' => $plugin_versions,
      ]];
    }
}
